#!/bin/bash
# http://www.xvid.org/
#
# script: til <rob DOT til DOT freedman AT googlemail DOT com>
REPO=http://zenwalk.pinguix.com/user-accounts/tilderb/extra/l/xvidcore
#
set -x -u -e

# xvidcore
version=1.2.2
build=66.1

arch=${arch:-i686}
cpu=${cpu:-i686}

pkgname=xvidcore-$version
package=$pkgname-$arch-$build

PKG_SRC="http://downloads.xvid.org/downloads/$pkgname.tar.bz2
$REPO/build-xvidcore.sh"
PKG_DEP=

# build directory
CWD=`pwd`
TMP=${TMP:-$CWD}
SRC=$TMP/$pkgname
PKG=$TMP/$package

# prepare build directory
[ -d $SRC ] && rm -fr $SRC
[ -d $PKG ] && rm -fr $PKG
#
mkdir -p $SRC $PKG/{install,usr/{src,doc}/$pkgname}
#
tar xf $CWD/$pkgname.tar.bz2 --strip-components=1 -C $SRC
cd $SRC
patch -p1 -i $CWD/xvid-1.2.2-noexecstack.patch

cd build/generic
#./bootstrap.sh

sed -i -e '/^minimum_yasm_minor_version/s:=.*:=0:' configure 

CFLAGS="-O2 -march=$arch -mtune=$cpu" \
	./configure --prefix=/usr
	
make || exit 1
make install DESTDIR=$PKG
# helperline
(cd $PKG;find . -printf "%y %M %u:%g %p %l\n" >$CWD/make.installed)
#
(	cd $PKG/usr/lib
	chmod 755 libxvidcore.so.4.2
	ln -s libxvidcore.so.4.2 libxvidcore.so.4
	ln -s libxvidcore.so.4.2 libxvidcore.so
)
# docs
cd $SRC
cp -a AUTHORS ChangeLog LICENSE $PKG/usr/doc/$pkgname

# copy build script
cp $CWD/build-xvidcore.sh $PKG/usr/src/$pkgname

# copy slack description
#    |-----handy-ruler------------------------------------------------------|
cat <<EOF > $PKG/install/slack-desc
xvidcore: xvidcore (ISO MPEG-4 Compliant Video Codec Library)
xvidcore:
xvidcore:    * MPEG-4 Video Codec library
xvidcore:    * SP/ASP/AVC de-/encoding support
xvidcore:    * Open-source software released under GPL license
xvidcore:    * Optimized for highest picture quality and archival purposes
xvidcore:    * Primary platform PC (Windows and Linux)
xvidcore:    * High-performance due to extensive assembly optimizations
EOF
#
#find $PKG | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs -r strip --strip-unneeded
find $PKG | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs -r strip --strip-unneeded
find $PKG | xargs file | grep "current ar archive" | cut -f 1 -d : | xargs -r strip -g

cd $PKG
fakeroot /sbin/makepkg -l y -c n $CWD/$package.txz

cd $CWD
echo "$PKG_SRC" >$package.src
echo -n $PKG_DEP >$package.dep
md5sum $package.tgz >$package.md5
